// $Id: BasicActor.h,v 1.1.1.1 2003/07/04 17:15:03 darseq Exp $
#ifndef BASICACTOR_H
#define BASICACTOR_H

// #define MSG_SIZE 80

#include <adk.hxx>
#include "ViewerWindow.h"
#include "logger.h"

using namespace Rescue;

typedef enum {AC_EXCHANGE=0,AA_SAY,CC_READY,CC_EXCHANGE,CA_READY} phase_t;

class BasicActor : public Controller {
    friend class AgentForm;
    private:
        // act calls update & think
        void act();
        // sense_change calls sense
        void sense_change(Object * object);
	Logger *m_logger;	
    protected:
        int agent_type; // different from type()
        S32 m_prev_time;
        bool mInitialized;

        phase_t phase;
        bool exchange;
        int hear_msgs;
        S32 m_last_hear;
        S32 m_last_send;
        S32 m_last_exchange;

        int mActs;
        View *mView,*mInfoView,*mDataView;
        class DataForm * mBrowser;
        class Behaviour * mLastBehaviour;
        class SituationModel * mLastTree;

        // called during the connection phase
        virtual void init();
        // called when m_time == STARTCYCLE
        virtual void initialize() {}
        virtual void sense(Object * object) {}
        virtual void update() {}
        virtual void think() {}
        virtual void act_say(char * msg);
        virtual void act_tell(char * msg);

    public:
        BasicActor(int type);
        ~BasicActor();

        class WorldModel * model() {return (class WorldModel *) m_memory;}
        bool Initialized() {return mInitialized;}
        void EnableLogging(char* filename);
        const char * agentName();
        void Draw(ViewerWindow * aWindow);
        void MouseClick(int x,int y,int b);
        void Key(int aKey);

        // getters
        int Type() { return agent_type; }
        virtual Object * Self() {
            // The ADK actually only works with MovingObjects. Centers
            // cannot use all ADK functionality. i.e act_move
            Object * obj = lookup<Object>(m_id);
            ASSERT(dynamic_cast<Building *>(obj) ||
                    dynamic_cast<Humanoid *>(obj));
            return obj;
        }
        virtual Object* Position()=0;
        S32 ID() {return m_id;}
        S32 Time() { return m_time; }
};
#endif

