// $Id: BasicAgent.h,v 1.2 2003/07/05 12:02:50 darseq Exp $
// copyright, s.post & cp
#ifndef BASICAGENT_H
#define BASICAGENT_H

#include "BasicActor.h"
#include "Message.h"
#include "path.h"

#define A_MAXMSGS 4
#define MSGS_C_A A_MAXMSGS
#define MSGS_C_CA 6
//#define MSGS_A_C 2
#define MSGS_A_C 1

class BasicAgent : public BasicActor {
    private:
        int center_msgs;

        void init();
        bool anAgent(Object * object);
        bool myCenter(Object * object);
        void hear(Object *sender, const char *msg);
        void act_say(char * msg);
        void act_tell(char * msg);
        void communicateWorld();
        bool ready2send();
        void update();
        void UpdateSenseTimes();

        Eltlst * destroyDuplicates(S32 id,char * c);
    protected:
        int mMoves,mActions;
        long mTotalThinkTime;
        Object ** mLastPath;
        Message say_msgs;

        virtual void think();
        virtual void sense(Object * object);
        virtual void Agentmsg(Object * sender,const char * msg);
        virtual void Exchange(Object * sender,const char * msg);
    public:
        BasicAgent(int type);
        ~BasicAgent();

        void Idle();
        void Move(Path * path);
        void PrintResults(FILE * file);

        long PositionExtra() {return((MovingObject*)Self())->positionExtra();}
        MotionlessObject * Position() {
            MotionlessObject * P =
                dynamic_cast<MotionlessObject*>(((MovingObject*)Self())->position());
            ASSERT(P);
            return  P;
        }
        Rescue::Memory::Location Location() {
            return Rescue::Memory::Location(Position(),PositionExtra());
        }

        long Direction() {return ((MovingObject*) Self())->direction();}
        long Stamina() {return ((Humanoid*)Self())->stamina();}
        long Hp() {return ((Humanoid*)Self())->hp();}
        long Damage() {return ((Humanoid*)Self())->damage();}
        long Buriedness() {return ((Humanoid*)Self())->buriedness();}
};
#endif

