// $Id: FireAgent.cpp,v 1.1.1.1 2003/07/04 17:15:03 darseq Exp $
#include "FireAgent.h"
#include <math.h>
#include "WorldModel.h"

//----------------------------------------------------------------------------

FireAgent::FireAgent():BasicAgent(AGENTTYPE_FIRE_COMPANY)
{
    
}


//----------------------------------------------------------------------------

void FireAgent::initialize()
{

}

//----------------------------------------------------------------------------

void FireAgent::act_extinguish_simple(Building *target)
{
  packet_start(m_output, AK_EXTINGUISH);
  m_output.put(m_id);
  // Nozzle
  m_output.put(target->id());
int X=m_self->x(),Y=m_self->y();
int tX=target->x(),tY=target->y();
int dX=tX-X,dY=tY-Y;
float d=atan2(dX,dY);
int dir=(int)(180.0*(d/M_PI));
  dir=(int)(1296000.0*d);
  m_output.put(dir); // Direction (??)
  m_output.put(X);
  m_output.put(Y);
  m_output.put(config.max_extinguish_power()); // Amount of water (per minute)
  m_output.put((Id) 0); // only use 1 nozzle
  packet_end(m_output);

#ifdef VERBOSE
  fprintf(stderr, "[%ld] Extinguish: %ld. (Fire = %d) \n", m_id, target->id(),target->fieryness());
#endif
}

void FireAgent::Extinguish(Building* B)
{
    mActions++;

    assert(B->type()==TYPE_BUILDING);
    assert(B->fieryness()>0);
    
    Debug(spam_output,"Output:[Agent %ld Time %ld] Extinguishing building B%ld (Water=%ld)\n",ID(),m_time,B->id(),WaterQuantity());
    act_extinguish_simple(B);
}
//----------------------------------------------------------------------------


