// $Id: Message.cpp,v 1.3 2003/07/05 12:02:50 darseq Exp $
// copyright, s.post
#include "Message.h"
#include "main.h"

Eltlst::~Eltlst() {
    for(iterator it = begin();it != end();it++) {
        delete (*it);
    }
}
//---------------------------------------------------------------------------

string Eltlst::lst2str() {
    string result = "(";
    iterator it = begin();
    while(it != end()) {
        if(dynamic_cast<Scalar *>(*it)) {
            result += ((Scalar *) *it)->toString();
        } else if(dynamic_cast<Eltlst *>(*it)) {
            result += ((Eltlst *) *it)->toString();
        }
        if(++it != end()) {result += ',';}
    }
    return result + ')';
}
//---------------------------------------------------------------------------

string Message::toString() {
    string message = header; str2elt_t::iterator it;
    for(it = str2elt.begin();it != str2elt.end();it++) {
        message += FIELD_DELIM + string(it->first) + STRDATA_SEP +
                    it->second->toString();
    }
    return message += MSG_DELIM;
}
//---------------------------------------------------------------------------

string Message::nthWord(string str,char delim,int n) {
    string result; char c;
    int delim_count=0; bool copy = (n == 0);
    for(unsigned int i=0;i < str.length();i++) {
        c = str[i]; if(copy) {result += c;}
        if(c == delim) {
            if(++delim_count == n) {copy = true;}
            else if(copy) {break;}
        }
    }
    if(delim_count > n) {result.resize(result.length()-1);}
    return result;
}
//---------------------------------------------------------------------------

string Message::nthElement(string str,int n) {
    string result; char c; int level=0;
    int comma_count=0; bool copy = (n == 0);
    for(unsigned int i=0;i < str.length();i++) {
        c = str[i]; if(copy) {result += c;}
        level += (c == '('); level -= (c == ')');
        if(level == 0 && c == ',') {
            if(++comma_count == n) {copy = true;}
            else if(copy) {break;}
        }
    }
    if(comma_count > n) {result.resize(result.length()-1);}
    return result;
}
//---------------------------------------------------------------------------

Eltlst * Message::str2lst(string str) {
    Eltlst * lst = new Eltlst(); string elt;
    string elements = str.substr(1,str.length()-2);
    for(int i=0;(elt = nthElement(elements,i)).length();i++) {
        if(elt[0] == '(') {lst->push_back(str2lst(elt));}
        else {lst->push_back(new Scalar(elt));}
    }
    return lst;
}
//---------------------------------------------------------------------------

void Message::unpackMessage(string message) {
    // read message header
    header = nthWord(message,FIELD_DELIM,0);
    ASSERT(header.length());

    // read other fields
    string field,str;
    for(int i=1;(field = nthWord(message,FIELD_DELIM,i)).length();i++) {
        str = nthWord(field,STRDATA_SEP,0); ASSERT(str.length());
//        ASSERT(str2elt.find(str) == str2elt.end());
        if(str2elt.find(str) != str2elt.end())
            fprintf(stderr,"maurits is een eikel!\n");
        string data(nthWord(field,STRDATA_SEP,1));
        if(data.length() > 1 && data[0] == '(') {
            str2elt[str] = str2lst(data);
        } else {
            str2elt[str] = new Scalar(data);
        }
    }
}
//---------------------------------------------------------------------------

void Message::insertElt(string str,Elt * elt) {
    str2elt_t::iterator it;
    if((it = str2elt.find(str)) == str2elt.end() || it->second == elt) {
        ASSERT(false);
    }
    str2elt[str] = elt;
}
//---------------------------------------------------------------------------

Elt * Message::getElt(string str) {
    return str2elt[str];
}
//---------------------------------------------------------------------------

