// $Id: Message.h,v 1.1.1.1 2003/07/04 17:15:03 darseq Exp $
// copyright, s.post
#ifndef MESSAGE_H
#define MESSAGE_H
#include <map>
#include <list>
#include <string>

using namespace std;

#define MSG_SIZE 80
#define MSG_DELIM '\n'
#define FIELD_DELIM '\t'
#define STRDATA_SEP '='

class Elt {
    public:
        virtual ~Elt() {}
        virtual string toString()=0;
};
typedef map<string,Elt *> str2elt_t;

class Scalar : public string,public Elt {
    public:
        Scalar(const string & str) : string(str){}
        virtual string toString() {return *((string *) this);}
};

class Eltlst : public list<Elt *>,public Elt {
    private:
        string lst2str();
    public:
        ~Eltlst(); // Message.cpp
        virtual string toString() {return lst2str();}
};

class Message {
private:
    str2elt_t str2elt;
    string nthWord(string str,char delim,int n);
    string nthElement(string str,int n);
    Eltlst * str2lst(string str);
    void unpackMessage(string message);
public:
    string header;
    Message() {}
    Message(string message) {unpackMessage(message);}
    ~Message() {clear();}

    void clear() {
        str2elt_t::iterator it = str2elt.begin();
        for(;it != str2elt.end();it++) {
            delete str2elt[it->first];
            str2elt.erase(it->first);
        }
    }

    string toString();
    void insertElt(string str,Elt * elt);
    Elt * getElt(string str);
};

//---------------------------------------------------------------------------
#endif

