
#ifndef TASK_H
#define TASK_H

/*
 * Task is a common goal that all members of one team shares
 * They are created and chosen by the centers/officers or whatever
 */

#include <vector>
#include <memory>
#include <string>

using namespace std;

class Task
{
protected:
    class Sector* mSector;
public: 
    Task()
    {
        mSector=0;
    }
    virtual class Sector* TargetSector()=0;
    virtual class Behaviours GenerateBehaviour(class TeamMember* aActor,class SituationModel* aSituation)=0;
    virtual string ToString()=0;
};

class FightFireTask : public Task
{
public:
    FightFireTask(class Sector* aSector) : Task()
    {
        mSector=aSector;
    }
    class Sector* TargetSector()
    {
        return mSector;
    }
    virtual class Behaviours GenerateBehaviour(class TeamMember* aActor,class SituationModel* aSituation);
    virtual string ToString();
};


class ImproveTravelTask : public Task
{
public:
    ImproveTravelTask(Sector* aSector) : Task()
    {
        mSector=aSector;
    }
    class Sector* TargetSector()
    {
        return mSector;
    }
    virtual class Behaviours GenerateBehaviour(class TeamMember* aActor,class SituationModel* aSituation);
    virtual string ToString();
};

class PatrolTask : public Task
{
protected:
public:
    PatrolTask() : Task()
    {
        mSector=0;
    }
    class Sector* TargetSector()
    {
        return 0;
    }
    virtual class Behaviours GenerateBehaviour(class TeamMember* aActor,class SituationModel* aSituation);
    virtual string ToString();
};

class ReconTask : public Task
{
public:
    ReconTask(Sector* aSector) : Task()
    {
        mSector=aSector;
    }
    class Sector* TargetSector()
    {
        return mSector;
    }
    virtual class Behaviours GenerateBehaviour(class TeamMember* aActor,class SituationModel* aSituation);
    virtual string ToString();
};

class SearchAndRescueTask : public Task
{
public:
    SearchAndRescueTask(Sector* aSector) : Task()
    {
        mSector=aSector;
    }
    class Sector* TargetSector()
    {
        return mSector;
    }
    virtual class Behaviours GenerateBehaviour(class TeamMember* aActor,class SituationModel* aSituation);
    virtual string ToString();
};
    
#endif
