#include "behaviour.h"
#include <float.h>
#include "../WorldModel.h"
#include "../SituationModel.h"
#include "../Team.h"
#include "../ViewerWindow.h"

float Behaviour::GeneralOperationalAttainabilityScore(TeamMember* aActor)
{
    return 1.0f;
    if (!aActor) // no one assigned
        return 0.0f;
    else if (aActor->Dead()) // exec is dead
        return 0.0f;
    else if (aActor->Buried()) // exec is disabled by being burried
        return 0.0f;
    else
        return 1.0f;
}


SituationModel* Behaviour::Predict(SituationModel* aSituation,TeamMember* aActor)
{
    SituationModel* O=new SituationModel(*aSituation);
    // check if the actors humanoid structure is up to date in out
    assert(aActor->Human()==O->GetHuman(aActor->Self()));
    
    return O;
}

// prediction helpers

SituationModel* Behaviour::PredictTravel(SituationModel* aSituation,TeamMember* aActor,Rescue::Object* aTarget)
{
    ImaginaryObject* new_position=aSituation->GetObject(aTarget);
    Path* P=aSituation->FindPath(aActor->Human(),new_position);
    if (P)
    {
        mPosition=new_position->ActualObject(); // queue to move to target
        ImaginaryHuman* H=(ImaginaryHuman*)aSituation->Override(aActor->Human());
        H->mPosition=aSituation->GetObject(P->GetReachablePosition());
        delete P;
        return aSituation;
    }
    mPosition=0;
    return 0;
}

SituationModel* Behaviour::PredictMove(SituationModel* aSituation,TeamMember* aActor,Rescue::Object* aTarget)
{
    ImaginaryHuman* H=(ImaginaryHuman*)aSituation->Override(aSituation->GetHuman(aActor->Self()));
    ImaginaryObject* new_position=aSituation->GetObject(aTarget);
    H->mPosition=new_position;
    mPosition=new_position->ActualObject();
    return aSituation;
}





void Behaviour::Draw(class ViewerWindow* aWindow)
{
    aWindow->Text(0.0,0.0,ToString());
}




