
#include "behaviourclear.h"
#include "../PoliceAgent.h"
#include "../Team.h"
#include "../SituationModel.h"
#include "../WorldModel.h"
#include "../Summary.h"

using namespace Rescue;


float BehaviourClear::Priority(SituationModel* aModel,TeamMember* aActor)
{
    if (!mPath)
    {
           const Path* R=aModel->WorldModel()->GetSummary()->GetHighway(mFrom,mTarget);
        if (!R) 
        {
            return 0.0;
            // TODO: // should not happen but does atm. assert(!=NULL) and find out why
        }
        mPath=new Path(*R);
    }
        return 0.4+(0.3*aModel->WorldModel()->GetSummary()->GetHighwayPriority(mFrom,mTarget))+
            (0.3*BehaviourSweepPath::Priority(aModel,aActor));
}

float BehaviourClear::Attainability(SituationModel* aModel,TeamMember* aActor)
{
    if (!mPath)
    {
        const Path* R=aModel->WorldModel()->GetSummary()->GetHighway(mFrom,mTarget);
        if (!R) 
        {
            return 0;
            // TODO: // should not happen but does atm. assert(!=NULL) and find out why
        }
        mPath=new Path(*R);
    }
    return BehaviourSweepPath::Attainability(aModel,aActor);
}

SituationModel* BehaviourClear::Predict(SituationModel* aSituation,TeamMember* aActor)
{
    if (!mPath)
    {
        const Path* R=aSituation->WorldModel()->GetSummary()->GetHighway(mFrom,mTarget);
        assert(R!=0);
        mPath=new Path(*R);
    }
    return BehaviourSweepPath::Predict(aSituation,aActor);
}



string BehaviourClear::ToString()
{
    return string("Clear HW "+IntToString(mFrom->id())+"-"+IntToString(mTarget->id()));
}

