#include "behaviourclearroad.h"
#include "../PoliceAgent.h"
#include "../Team.h"
#include "../SituationModel.h"


struct ClearPositionFn2 : public Memory::ObjectFn
{
    Road* target_road;

    virtual bool consider(const Rescue::Object * o) const
    {
        if (o->type()==TYPE_NODE)
        {
            Node* n=(Node*)o;
            Rescue::Objects::const_iterator i;
            for (i=n->neighbors().begin();i!=n->neighbors().end();i++)
            {
                if (*i==target_road)
                {
                    return true;
                }
            }
        }
        return false;
    }
    virtual double f(const Rescue::Object *o) const
    {
        return 0.0;
    }
    ClearPositionFn2(Road* target) : ObjectFn()
    {
        target_road=target;
    }
};

float BehaviourClearRoad::Priority(SituationModel* aModel,TeamMember* aActor)
{
    // TODO calc once for optimization and update on changes in neighbours and fieryness
    ImaginaryRoad* R=aModel->GetRoad(mTarget);
    if (R)
    {
        return 1.0f - R->mBlock;
    }
    else
    {
        return 0.0f;
    }
}

float BehaviourClearRoad::Attainability(SituationModel* aModel,TeamMember* aActor)
{
    ImaginaryRoad* R=aModel->GetRoad(mTarget);
    if ((R) && (R->mBlock>0))
    {
        return GeneralOperationalAttainabilityScore(aActor);
    }
    return 0.0f;
}

void BehaviourClearRoad::Execute(BasicAgent* aExec)
{
    Debug(spam_behaviour_execution,"Executing %s by %s %04ld\n",ToString().c_str(),aExec->agentName(),aExec->ID());
}

string BehaviourClearRoad::ToString()
{
    return string("Clear road "+IntToString(((Road*)mTarget)->id()));
}


