#include "behaviourtravel.h"
#include "../Team.h"
#include "../SituationModel.h"
#include "../WorldModel.h"


float BehaviourTravel::Priority(SituationModel* aModel,TeamMember* aActor)
{
    return 0.1;
}

float BehaviourTravel::Attainability(SituationModel* aModel,TeamMember* aActor)
{
    return 1.0f;
}


SituationModel* BehaviourTravel::Predict(SituationModel* aSituation,TeamMember* aActor)
{
    SituationModel* out=Behaviour::Predict(aSituation,aActor);

    if (aActor->Position()->ActualObject()==mTarget)
    {
        mPosition=0;
        return out;
    }
    else
    {
        const objects_t& nexi=mSector->nexusPoints();
        for(objects_t::const_iterator NI=nexi.begin();NI!=nexi.end();NI++)
        {
            SituationModel* out2=PredictTravel(out,aActor,*NI);
            if (out2)
            {
                return out2;
            }
        }
        return 0;
    }
}

void BehaviourTravel::Execute(BasicAgent* aExec)
{
    Debug(spam_behaviour_execution,"Executing %s by %s %04ld\n",ToString().c_str(),aExec->agentName(),aExec->ID());
    WorldModel* WM=aExec->model();
    if (mPosition)
    {
        Path* P=WM->FindPath(aExec->Self(),mPosition,Path::AdvancedTravelFn(aExec));
        if (P)
        {
            aExec->Move(P);
        }
    }
}

string BehaviourTravel::ToString()
{
    return string("Travel to sector "+IntToString(mSector->ID()));
}
