#ifndef _MAIN_H_INCLUDED
#define _MAIN_H_INCLUDED

#include <adk.hxx>
#include <Config.hxx>
#include <assert.h>
#include <vector>
#include <string>
#include "BasicActor.h"

#define xconcat(arg1,arg2) concat(arg1,arg2)
#define concat(arg1,arg2) arg1 ## arg2.h
#define xstr(s) str(s)
#define str(s) #s

extern Rescue::Config config;
extern FILE* g_analysis_file;
extern class ViewerWindow* gViewerWindow;
extern vector<BasicActor*> gActors;
extern int gSectorX;
extern int gSectorY;
extern int g_spamflag;
enum spam_enum {
    spam_spam= 1<<0, // 1
    spam_startup= 1<<1,  // 2
    spam_behaviour_selection= 1<<2, // 4
    spam_behaviour_execution= 1<<3, // 8
    spam_group_information= 1<<4,// 16
    spam_agent_communication= 1<<5, // 32
    spam_path=1<<6, // 64
    spam_performance=1<<7, // 128
    spam_input=1<<8,// 256
    spam_output=1<<9,// 512
    spam_all_spam=0xFFFFFF
};

void Debug(int flag,const char* format,...);

char ObjectTypeToChar(Rescue::TypeId type);
void  GetObjectPosition(const Rescue::Object* obj,double& x,double& y);
void  GetObjectPosition(const Rescue::Object* obj,long& x,long& y);
double DistanceBetween(const Rescue::Object* A,const Rescue::Object* B);
unsigned long timer();

string IntToString(int value);
string FloatToString(float value);

#endif // _MAIN_H_INCLUDED
